/*****************************************************************************\
 *
 * kframeDatabase.h
 *
 * Updated: 21.5.2006
 * 
 * kframeDatabaseLib3  - declaration of kframeDatabaseLib3 class
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _kframeDatabaseLib3_h_
#define _kframeDatabaseLib3_h_

#include "lib3ds.h"

struct kframeDatabaseLib3 {  

  private:

    kframeListLib3	  kframeList;
    kfmeshLib3        *kframe;

    FILE              *inputFile;

    int               nodeIdFound;

  public:

    void addKFandNode(int);
    void addHeader();
    void addPivot();
    void addInstanceName();
    void addBoundingBox();
    void addPositionTT();
    void addRotationTT();
    void addScaleTT();

    kfmeshLib3 *dbGetKframe(char *);
    kfmeshLib3 *dbGetKframeInstanceByIndex(char *, int);
    int dbGetMeshInstanceCount(char *);

    kframeDatabaseLib3(FILE *);
    ~kframeDatabaseLib3();
};

#endif
