/*****************************************************************************\
 *
 * materialDatabase.h
 *
 * Updated: 21.5.2006
 * 
 * materialDatabaseLib3  - declaration of materialDatabaseLib3 class
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _materialDatabaseLib3_h_
#define _materialDatabaseLib3_h_

#include "lib3ds.h"

enum col_type {
  col_unknown,
  ambient,
  diffuse,
  specular
};

enum per_type {
  per_unknown,
  shininess,
  shin2pct,
  transparency,
  xpfall,
  refblur,
  selfillpct,
  texture,
  bump
};

enum attr_type {
  usefall,
  useblur,
  selfillum,
  twosided,
  decal,
  additive,
  usewire,
  facemap,
  soften,
  usewireabs
};

struct materialDatabaseLib3 {  

  private:

    materialListLib3	materialList;
    materialLib3	  	*material;
    FILE              *inputFile;

    col_type color_type;
    per_type percent_type;

  public:

    void setColorType(col_type color);
    void setPercentFor(per_type percent);
    void setAtribute(attr_type atribute, int value);
    void setShading();
    void setWireSize();
    void readIntPercentage();
    void readColor24();
    void readLinearColor24();
    
    void addMapName();
    void addMapTiling();
    void addMapTexBlur();
    void addMapUscale();
    void addMapVscale();
    void addMapUoffset();
    void addMapVoffset();
    void addMapAngle();

    void addMaterial();

    materialListLib3 *dbGetMaterialList();
    materialLib3 *dbGetMaterial(int);

    materialDatabaseLib3(FILE *);
    ~materialDatabaseLib3();
};

#endif
