/*****************************************************************************\
 *
 * keyFrameClass.h
 *
 * Updated: 21.5.2006
 * 
 * textureClass  - class for works with keyframe information
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _keyFrameClass_h_
#define _keyFrameClass_h_

#include <Inventor/nodes/SoSeparator.h>

#include "sceneClass.h"

/*
 *Class for processing keyframe part of 3ds file
 */
class keyFrameClass : sceneClass {
  
  lib3ds  *kfmodel;

  void findTopParent(int *clockshape, SbVec3f *pos, SbVec4f *rot, SbVec3f *scl, kfmeshLib3 *kfmesh);

public:

  // perform keyframe transformations on model
  void performKFTransformations(int *);

  keyFrameClass() {};
  keyFrameClass(sceneClass *, int);  
  ~keyFrameClass();
};
#endif

