/*****************************************************************************\
 *
 * materialClass.h
 *
 * Updated: 21.5.2006
 * 
 * materialClass  - class for material
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _materialClass_h_
#define _materialClass_h_

#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoDrawStyle.h>
#include <Inventor/nodes/SoLightModel.h>

#include "lib3ds.h"
#include "sceneClass.h"

/*
 * Class for processing material information, but don't processing textures.
 */
class materialClass : sceneClass {

  // some material attributes
  #define MY_MAT_DEFAULT 0
  #define MY_MAT_TWO_SIDED 1
  
  // add material attributes to scene graph
  void addMaterialAttr(int attr, int clockshape);
  
public:
    
  // add material to scene graph
  void addMaterial(int clockshape);

  materialClass() {};
  materialClass(sceneClass *);
  ~materialClass();
};
#endif
