/*****************************************************************************\
 *
 * textureClass.h
 *
 * Updated: 21.5.2006
 * 
 * textureClass  - class for works textures
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _textureClass_h_
#define _textureClass_h_

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoTextureCoordinate2.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoTextureCoordinateBinding.h>
#include <Inventor/nodes/SoTexture2Transform.h>

#include <Inventor/nodes/SoTextureUnit.h>

#include <Inventor/nodes/SoBumpMap.h>
#include <Inventor/nodes/SoBumpMapCoordinate.h>
#include <Inventor/nodes/SoBumpMapTransform.h>

#include <iostream>

#include "sceneClass.h"

/*
 * Class for processing textures in scene
 */
class textureClass : sceneClass {
    
  // add texture coordinates to scene
  void addTextureCoords();

  params param;
  
public:

  // add texture attributes to scene
  void addTextureAttr();
  // add texture to scene graph
  void addTexture();

  textureClass() {};
  textureClass(sceneClass *);  
  ~textureClass();
};
#endif
