/*****************************************************************************\
 *
 * meshDatabase.h
 *
 * Updated: 21.5.2006
 * 
 * meshDatabaseLib3  - declaration of meshDatabaseLib3 class
 *
 * Author: Jaroslav Pribyl (xpriby05 _AT stud.fit.vutbr.cz)
 *
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#ifndef _meshDatabaseLib3_h_
#define _meshDatabaseLib3_h_

#include <math.h>
#include "lib3ds.h"

struct meshDatabaseLib3 {  

  private:

    meshListLib3		  meshList;
    meshLib3		    	*mesh;
    FILE              *inputFile;

  public:

    void addMesh(char *name);
    void addPointArray();
    void addPointFlagArray();
    void addFaceArray();
    void addMeshMatGroup();
    void addSmoothArray();
    void meshDatabaseLib3::check_for_wrap(textLib3 *tv, unsigned short int flags);
    void addTextVertArray();
    void addMeshMatrix();

    meshListLib3 *dbGetMeshList();
    meshLib3 *dbGetMesh(int);

    meshDatabaseLib3(FILE *);
    ~meshDatabaseLib3();
};

#endif
